Unit General;

Interface

 Type
   ErrorKind = ( ambiguous3, comment3, chain3, Kind3,
		 numeral3, nestedParallel3, PrivateAssig3, proc3, paralleldo3,
		 range3, readOnly3, Status3, syntax3,
                 threshold3, type3, undefined3);
 var
   finput, fcode, temp1, temp2, flis, notes : text;
   lineno, ErrorsNo: integer;
   emitting, Errors, correctline : boolean;
   source, code : string[20];
   a : word;

 procedure emit( var f : text; value: longint);
 procedure rerun;
 procedure newline(number:integer);
 procedure Error(Kind:ErrorKind);
 procedure testlimit(length,maximun: integer);

implementation


procedure emit( var f : text; Value: longint);
begin
 if emitting then WriteLn( f , value);
end;

procedure rerun;
begin
  reset(temp2);
  emitting := true;
end;

procedure newline(number: integer);
begin
 lineno := number;
 correctline := true
end;

procedure Error(Kind :ErrorKind);
var
  texto : string;
begin
  if not Errors then
     begin
      rewrite(notes);
      emitting := false;
      Errors:=true;
      ErrorsNo := 1;
     end;
  case Kind of
    ambiguous3      : texto := 'Nombre Ambiguo.';
    comment3        : texto := 'Comentario No Vlido .';
    chain3          : texto := 'Cadena no finalizada';
    Kind3           : texto := 'Clase De Nombre No Vlida.';
    numeral3        : texto := 'Numeral No Vlido.';
    nestedParallel3 : texto := 'Parallel Anidado.';
    PrivateAssig3   : texto := 'Uso errneo de .=';
    proc3           : texto := 'Llamada a un Procedure en Paralelo.';
    paralleldo3     : texto := 'Imposible llamar en paralelo a dos task diferentes';
    range3          : texto := 'Rango De Indice No Vlido.';
    readOnly3       : texto := 'Se intenta acceder a Name para escribir';
    status3         : texto := 'Estado Errneo (Private, Shared ).';
    syntax3         : texto := 'Sintaxis No Vlida.';
    threshold3      : texto := 'Valor no autorizado de Theshold';
    type3           : texto := 'Tipo No Vlido.';
    undefined3      : texto := 'Nombre No Definido.'
  end;

  if correctline then
    begin
      ErrorsNo := ErrorsNo + 1;
      writeln(notes, ' Lnea   ',lineno:4, ':  ', texto);
      if ErrorsNo <= 20 then
        writeln(' Lnea   ',lineno:4, ':  ', texto);
      correctline := false
    end
end;

procedure testlimit(length, maximun: integer);
begin
  if length >= maximun then
    begin
      writeln;
      writeln('Programa Demasiado Grande.');
    end
end;

begin
  assign( temp1, 'temp1.$$$');
  assign( temp2, 'temp2.$$$');
  Errors := false;
  emitting:= true;
end.
