Program Parallel_Pascal_Compiler;
(*
HISTORIA: Esta se supone ser la version 1.0
          Se empieza a modificar el 1-3-94
          25.04.94:  Notes.err se elimina y es file.err
          25.04.94:  debug deja de tener parmetros. debug; a secas
          25.04.94:  For descendente, LOOP label Step
          26.05.94:  Threshold de 1
*)
Uses
  Crt, General, AnaLex, AnaSin, Ensam;

begin

  Clrscr;
  HighVideo;
  Write('P');
  NormVideo;
  Write('ascal ll ');
  HighVideo;
  Write('C');
  NormVideo;
  Writeln('ompiler.  ( Versin 1.0 del 26.5.94)  ');
  Writeln; writeln;

  if ParamCount = 0 then
    begin
      Write(' Source File [.ll] : ');
      ReadLn(source);
      if source = '' then Halt;
    end
  else
    begin
      source := ParamStr(1);
      a := Pos( '.ll', source );
      if a <> 0 then  Writeln(' Source File [ ',source + ']. ')
      else Writeln(' Source File [ ',source + '.ll ]. ');
    end;

  a := Pos( '.ll', source );
  if a <> 0 then
    code := Copy(source,1,a - 1)
  else
    begin
      code := source;
      source := source + '.ll';
    end;

  Assign(finput,source);
  {$I-}
  Reset(finput);
  {$I+}
  if ( IOResult <> 0) then
     begin
        Writeln( #13,#10,'Error. File ', source , ' not found.');
        Halt;
     end;

  assign( notes, code + '.err');
  { Delete Errors File, if it exist of old sessiones}
  {$I-}
  Reset(notes);
  {$I+}
  if IOresult = 0 then
    begin
      Close(notes);
      Erase(notes);
    end;

  ReWrite(temp1);
  Analizador_Lexico;
  Close(finput);
  Close(temp1);

  if not errors then
   begin
     Reset(temp1);
     ReWrite(temp2);
     Analizador_Sintactico;
     Close(temp1);
     Close(temp2);
     Erase(temp1);
   end;

  if not errors then
   begin
     Reset(temp2);
     Assign( fcode, code + '.eje');
     ReWrite(fcode);
     emitting := false;
     Ensamblador;
     Close(temp2);
     Close(fcode);
     Erase(temp2);
   end;

  if errors then
    begin
      Close(notes);
      Writeln;
      Writeln('File of Errors [ ', code + '.err ] . ' );
      Writeln;
    end
  else
    begin
      Writeln;
      Writeln(' Executable File [ ', code + '.eje ]. ' );
      Writeln;
      Writeln(' Information File [ ', code + '.lis ]. ');
      Writeln;
    end
end.